/* ************************************************************************** */
/** Descriptive File Name

  @Company
    Company Name

  @File Name
    filename.h

  @Summary
    Brief description of the file.

  @Description
    Describe the purpose of this file.
 */
/* ************************************************************************** */

#ifndef USTV_SYSTEMTRACE_H    /* Guard against multiple inclusion */
#define USTV_SYSTEMTRACE_H
#include "HighBlue_Configuration.h"


/* ************************************************************************** */
/* ************************************************************************** */
/* Section: Included Files                                                    */
/* ************************************************************************** */
/* ************************************************************************** */

/* This section lists the other files that are included in this file.
 */

/* TODO:  Include other files here if needed. */

//#define SYS_TRACE_STATIC

/* Provide C++ Compatibility */
#ifdef __cplusplus
extern "C" {
#endif


    /* ************************************************************************** */
    /* ************************************************************************** */
    /* Section: Constants                                                         */
    /* ************************************************************************** */
    /* ************************************************************************** */

    #define SYS_TRACE_FILENAME          "/SysTrace.log"
    #define SYS_TRACE_BALISE_STR        "//==========Writing TraceBuffer=========//\n"
    #define SYS_TRACE_END_BALISE_STR    "//========End Writing TraceBuffer=======//\n"
   


    // *****************************************************************************
    // *****************************************************************************
    // Section: Data Types
    // *****************************************************************************
    // *****************************************************************************

   


    // *****************************************************************************
    // *****************************************************************************
    // Section: Interface Functions
    // *****************************************************************************
    // *****************************************************************************
    void USTV_SystemTraceInit(void);
    void USTV_SystemTraceWriteLineToBuffer(char* str);
    void USTV_SystemTraceWriteLine(char* str);
    void USTV_SystemTraceWriteBufferToFile(void);
   


    /* Provide C++ Compatibility */
#ifdef __cplusplus
}
#endif

#endif /* _EXAMPLE_FILE_NAME_H */

/* *****************************************************************************
 End of File
 */
